base_url = 'https://api.twitter.com/{version}/'

rest_endpoints = {
	'my_mentions': {
		'method': 'GET',
		'endpoint': 'statuses/mentions_timeline'
	},
	'my_timeline': {
		'method': 'GET',
		'endpoint': 'statuses/user_timeline'
	},
	'my_home_timeline': {
		'method': 'GET',
		'endpoint': 'statuses/home_timeline'
	},
	'retweets_of_me': {
		'method': 'GET',
		'endpoint': 'statuses/retweets_of_me'
	},
	'retweets_of_tweet': {
		'method': 'GET',
		'endpoint': 'statuses/retweets/{id}'
	},
	'show_tweet': {
		'method': 'GET',
		'endpoint': 'statuses/show/{id}'
	},
	'destroy_tweet': {
		'method': 'POST',
		'endpoint': 'statuses/destroy/{id}'
	},
	'tweet': {
		'method': 'POST',
		'endpoint': 'statuses/update'
	},
	'retweet': {
		'method': 'POST',
		'endpoint': 'statuses/retweet/{id}'
	},
	#'tweet_with_media': {
	#	'method': 'POST',
	#	'endpoint': 'statuses/update_with_media'
	#},
	'tweet_oembed_info': {
		'method': 'GET',
		'endpoint': 'statuses/oembed'
	},
	'search_tweets': {
		'method': 'GET',
		'endpoint': 'search/tweets'
	},
	#'stream_public_filtered': {
	#	'method': 'POST',
	#	'endpoint': 'statuses/filter'
	#},
	#'stream_public_sample': {
	#	'method': 'GET',
	#	'endpoint': 'statuses/sample'
	#},
	#'stream_public_firehose': {
	#	'method': 'GET',
	#	'endpoint': 'statuses/firehose'
	#},
	#'stream_user': {
	#	'method': 'GET',
	#	'endpoint': 'user'
	#},
	#'stream_site': {
	#	'method': 'GET',
	#	'endpoint': 'site'
	#},
	'my_received_direct_messages': {
		'method': 'GET',
		'endpoint': 'direct_messages'
	},
	'my_sent_direct_messages': {
		'method': 'GET',
		'endpoint': 'direct_messages/sent'
	},
	'show_direct_message': {
		'method': 'GET',
		'endpoint': 'direct_messages/show'
	},
	'destroy_direct_message': {
		'method': 'POST',
		'endpoint': 'direct_messages/destroy'
	},
	'send_direct_message': {
		'method': 'POST',
		'endpoint': 'direct_messages/new'
	},
	'my_retweet_blocked_user_ids': {
		'method': 'GET',
		'endpoint': 'friendships/no_retweets/ids'
	},
	'friends_of_my_followed_as_ids': {
		'method': 'GET',
		'endpoint': 'friends/ids'
	},
	'friends_of_my_followers_as_ids': {
		'method': 'GET',
		'endpoint': 'followers/ids'
	},
	'my_friendship_status': {
		'method': 'GET',
		'endpoint': 'friendships/lookup'
	},
	'my_incoming_follow_requests': {
		'method': 'GET',
		'endpoint': 'friendships/incoming'
	},
	'my_outgoing_follow_requests': {
		'method': 'GET',
		'endpoint': 'friendships/outgoing'
	},
	'follow': {
		'method': 'POST',
		'endpoint': 'friendships/create'
	},
	'unfollow': {
		'method': 'POST',
		'endpoint': 'friendships/destroy'
	},
	'update_friendship': {
		'method': 'POST',
		'endpoint': 'friendships/update'
	},
	'show_friendship': {
		'method': 'GET',
		'endpoint': 'friendships/show'
	},
	'friends_of_my_followed_as_objects': {
		'method': 'GET',
		'endpoint': 'friends/list'
	},
	'friends_of_my_followers_as_objects': {
		'method': 'GET',
		'endpoint': 'followers/list'
	},
	'my_account_settings': {
		'method': 'GET',
		'endpoint': 'account/settings'
	},
	'verify_my_credentials': {
		'method': 'GET',
		'endpoint': 'account/verify_credentials'
	},
	'update_my_settings': {
		'method': 'POST',
		'endpoint': 'account/settings'
	},
	'update_my_device_delivery': {
		'method': 'POST',
		'endpoint': 'account/update_delivery_device'
	},
	'update_my_profie': {
		'method': 'POST',
		'endpoint': 'account/update_profile'
	},
	#'update_my_profile background_pic': {
	#	'method': 'POST',
	#	'endpoint': 'account/update_profile_background_image'
	#},
	'update_my_profile_colors': {
		'method': 'POST',
		'endpoint': 'account/update_profile_colors'
	},
	#'update_my_profile_pic': {
	#	'method': 'POST',
	#	'endpoint': 'account/update_profile_image'
	#},
	'my_blocked_accounts_as_objects': {
		'method': 'GET',
		'endpoint': 'blocks/list'
	},
	'my_blocked_accounts_as_ids': {
		'method': 'GET',
		'endpoint': 'blocks/ids'
	},
	'block_user': {
		'method': 'POST',
		'endpoint': 'blocks/create'
	},
	'unblock_user': {
		'method': 'POST',
		'endpoint': 'blocks/destroy'
	},
	'lookup_users': {
		'method': 'GET',
		'endpoint': 'users/lookup'
	},
	'show_user': {
		'method': 'GET',
		'endpoint': 'users/show'
	},
	'search_users': {
		'method': 'GET',
		'endpoint': 'users/search'
	},
	'my_potential_contributees': {
		'method': 'GET',
		'endpoint': 'users/contributees'
	},
	'my_potential_contributors': {
		'method': 'GET',
		'endpoint': 'users/contributors'
	},
	'remove_my_banner': {
		'method': 'POST',
		'endpoint': 'account/remove_profile_banner'
	},
	#'update_my_banner': {
	#	'method': 'POST',
	#	'endpoint': 'account/update_profile_banner'
	#},
	'user_banner': {
		'method': 'GET',
		'endpoint': 'users/profile_banner'
	},
	'suggested_followers_in_category': {
		'method': 'GET',
		'endpoint': 'users/suggestions/{slug}'
	},
	'suggested_follower_categories': {
		'method': 'GET',
		'endpoint': 'users/suggestions'
	},
	'statuses_of_suggested_followers_in_category': {
		'method': 'GET',
		'endpoint': 'users/suggestions/{slug}/members'
	},
	'my_recent_favorites': {
		'method': 'GET',
		'endpoint': 'favorites/list'
	},
	'destroy_favorite': {
		'method': 'POST',
		'endpoint': 'favorites/destroy'
	},
	'favorite_tweet': {
		'method': 'POST',
		'endpoint': 'favorites/create'
	},
	'user_list_subscriptions': {
		'method': 'GET',
		'endpoint': 'lists/list'
	},
	'list_timeline': {
		'method': 'GET',
		'endpoint': 'lists/statuses'
	},
	'remove_user_from_list': {
		'method': 'POST',
		'endpoint': 'lists/members/destroy'
	},
	'user_list_memberships': {
		'method': 'GET',
		'endpoint': 'lists/memberships'
	},
	'list_subscribers': {
		'method': 'GET',
		'endpoint': 'lists/subscribers'
	},
	'subscribe_to_list': {
		'method': 'POST',
		'endpoint': 'lists/subscribers/create'
	},
	'user_subscription_status': {
		'method': 'GET',
		'endpoint': 'lists/subscribers/show'
	},
	'unsubscribe_from_list': {
		'method': 'POST',
		'endpoint': 'lists/subscribers/destroy'
	},
	'add_members_to_list': {
		'method': 'POST',
		'endpoint': 'lists/members/create_all'
	},
	'user_member_status': {
		'method': 'GET',
		'endpoint': 'lists/members/show'
	},
	'list_members': {
		'method': 'GET',
		'endpoint': 'lists/members'
	},
	'add_member_to_list': {
		'method': 'POST',
		'endpoint': 'lists/members/create'
	},
	'destroy_list': {
		'method': 'POST',
		'endpoint': 'lists/destroy'
	},
	'update_list': {
		'method': 'POST',
		'endpoint': 'lists/update'
	},
	'create_list': {
		'method': 'POST',
		'endpoint': 'lists/create'
	},
	'show_list': {
		'method': 'GET',
		'endpoint': 'lists/show'
	},
	'user_list_subscriptions_no_personal': {
		'method': 'GET',
		'endpoint': 'lists/subscriptions'
	},
	'remove_members_from_list': {
		'method': 'POST',
		'endpoint': 'lists/members/destroy_all'
	},
	'my_saved_searches': {
		'method': 'GET',
		'endpoint': 'saved_searches/list'
	},
	'get_saved_search': {
		'method': 'GET',
		'endpoint': 'saved_searches/show/{id}'
	},
	'save_search': {
		'method': 'POST',
		'endpoint': 'saved_searches/create'
	},
	'destroy_saved_search': {
		'method': 'POST',
		'endpoint': 'saved_searches/destroy/{id}'
	},
	'place_info': {
		'method': 'GET',
		'endpoint': 'geo/id/{place_id}'
	},
	'find_place_ids': {
		'method': 'GET',
		'endpoint': 'geo/reverse_geocode'
	},
	'search_places': {
		'method': 'GET',
		'endpoint': 'geo/search'
	},
	'similar_places': {
		'method': 'GET',
		'endpoint': 'geo/similar_places'
	},
	'create_place': {
		'method': 'POST',
		'endpoint': 'geo/place'
	},
	'trending_in_location': {
		'method': 'GET',
		'endpoint': 'trends/place'
	},
	'available_trend_locations': {
		'method': 'GET',
		'endpoint': 'trends/available'
	},
	'closest_trend_location': {
		'method': 'GET',
		'endpoint': 'trends/closest'
	},
	'report_spam': {
		'method': 'POST',
		'endpoint': 'users/report_spam'
	},
	#'authenticate_user': {
	#	'method': 'GET',
	#	'endpoint': 'oauth/authenticate'
	#},
	#'authorize_user': {
	#	'method': 'GET',
	#	'endpoint': 'oauth/authorize'
	#},
	#'request_access_token': {
	#	'method': 'POST',
	#	'endpoint': 'oauth/access_token'
	#},
	#'request_request_token': {
	#	'method': 'POST',
	#	'endpoint': 'oauth/request_token'
	#},
	'current_twitter_config': {
		'method': 'GET',
		'endpoint': 'help/configuration'
	},
	'current_supported_languages': {
		'method': 'GET',
		'endpoint': 'help/languages'
	},
	'current_privacy_policy': {
		'method': 'GET',
		'endpoint': 'help/privacy'
	},
	'current_terms_of_service': {
		'method': 'GET',
		'endpoint': 'help/tos'
	},
	'app_rate_limit_status': {
		'method': 'GET',
		'endpoint': 'application/rate_limit_status'
	}
}

rest_errors = {
	400: "Bad Request",
	401: "Unauthorized",
	403: "Forbidden",
	404: "Not Found",
	406: "Not Acceptable",
	422: "Unprocessable Entry",
	429: "Too Many Requests",
	500: "Internal Server Error",
	502: "Bad Gateway",
	503: "Service Unavailable",
	504: "Gateway Timeout"
}
